DROP TABLE IF EXISTS `symph_extensions`;
DROP TABLE IF EXISTS `symph_modules`;
DROP TABLE IF EXISTS `symph_newsletters`;
DROP TABLE IF EXISTS `symph_pages`;
DROP TABLE IF EXISTS `symph_simple_html`;
DROP TABLE IF EXISTS `symph_tour`;
DROP TABLE IF EXISTS `symph_users`;

CREATE TABLE `symph_extensions` (  `extension_id` int(11) NOT NULL auto_increment,  `extension_name` varchar(255) NOT NULL default '',  PRIMARY KEY  (`extension_id`)) TYPE=MyISAM AUTO_INCREMENT=11 ;

INSERT INTO `symph_extensions` (`extension_id`, `extension_name`) VALUES (1, 'symph_simple_html'),(2, 'symph_users');

CREATE TABLE `symph_modules` (  `module_id` int(11) NOT NULL auto_increment,  `module_name` varchar(255) NOT NULL default '',  `module_extension_id` int(11) NOT NULL default '0',  PRIMARY KEY  (`module_id`)) TYPE=MyISAM PACK_KEYS=0 AUTO_INCREMENT=28 ;

INSERT INTO `symph_modules` (`module_id`, `module_name`, `module_extension_id`) VALUES (2, 'ViewSimpleHTML', 1),(3, 'CreatePageContent', 1),(4, 'DeletePage', 1),(5, 'WriteMessage', 1),(6, 'ShowEditTree', 1),(7, 'MovePage', 1),(8, 'AddPage', 1),(9, 'EditPage', 1),(17, 'Authentication', 2),(18, 'LoadEditor', 1),(22, 'RenderText', 1),(23, 'NewsletterSubscription', 2),(24, 'RenderHTML', 1),(25, 'RenderBreadcrumb', 1),(26, 'RenderMenu', 1),(27, 'RenderInfo', 1);

CREATE TABLE `symph_newsletters` (  `newsletter_id` int(11) NOT NULL auto_increment,  `newsletter_subject` varchar(255) NOT NULL default '',  `newsletter_content` text NOT NULL,  `newsletter_date` date NOT NULL default '0000-00-00',  `newsletter_from` varchar(255) NOT NULL default '',  `newsletter_users` int(11) NOT NULL default '0',  PRIMARY KEY  (`newsletter_id`)) TYPE=MyISAM AUTO_INCREMENT=63 ;

CREATE TABLE `symph_pages` (  `page_id` int(11) NOT NULL auto_increment,  `page_parent_id` int(11) NOT NULL default '0',  `page_order` int(11) NOT NULL default '0',  `page_extension_id` int(11) NOT NULL default '0',  `simple_page_id` int(11) NOT NULL default '0',  `page_link` varchar(255) NOT NULL default '',  `page_tree` int(11) NOT NULL default '1',  `page_status` tinyint(4) NOT NULL default '1',  `page_start` date NOT NULL default '0000-00-00',  `page_expire` date NOT NULL default '0000-00-00',  `page_edit_locked` char(1) NOT NULL default '0',  `page_move_locked` char(1) NOT NULL default '0',  `page_redirect` int(2) NOT NULL default '0',  `page_redirect_url` varchar(255) NOT NULL default '',  PRIMARY KEY  (`page_id`)) TYPE=MyISAM PACK_KEYS=1 AUTO_INCREMENT=484 ;

INSERT INTO `symph_pages` (`page_id`, `page_parent_id`, `page_order`, `page_extension_id`, `simple_page_id`, `page_link`, `page_tree`, `page_status`, `page_start`, `page_expire`, `page_edit_locked`, `page_move_locked`, `page_redirect`, `page_redirect_url`) VALUES (1, 0, 0, 1, 1, '', 1, 1, '0000-00-00', '0000-00-00', '0', '0', 0, ''),(289, 101, 3, 1, 306, '/Insite-pages/FAQs', 0, 1, '0000-00-00', '0000-00-00', '0', '0', 0, 'http://'),(101, 0, 0, 1, 101, '', 0, 0, '0000-00-00', '0000-00-00', '0', '0', 0, ''),(103, 101, 1, 1, 103, '', 0, 1, '0000-00-00', '0000-00-00', '0', '0', 0, ''),(106, 101, 2, 1, 244, '', 0, 1, '0000-00-00', '0000-00-00', '0', '0', 0, ''),(290, 1, 1, 1, 1, '', 1, 1, '0000-00-00', '0000-00-00', '0', '0', 0, ''),(425, 101, 4, 1, 3, '', 0, 1, '0000-00-00', '0000-00-00', '0', '0', 0, '');

CREATE TABLE `symph_simple_html` (  `page_id` int(11) NOT NULL auto_increment,  `page_name` varchar(255) NOT NULL default '',  `page_title` varchar(255) NOT NULL default '',  `page_author` varchar(255) NOT NULL default '',  `page_description` text NOT NULL,  `page_keywords` text NOT NULL,  `page_html` text NOT NULL,  `page_template` varchar(255) NOT NULL default 'index.html',  `page_icon` varchar(255) NOT NULL default 'node',  PRIMARY KEY  (`page_id`)) TYPE=MyISAM PACK_KEYS=1 AUTO_INCREMENT=512 ;

INSERT INTO `symph_simple_html` (`page_id`, `page_name`, `page_title`, `page_author`, `page_description`, `page_keywords`, `page_html`, `page_template`, `page_icon`) VALUES (1, 'Homepage', 'Homepage', '', '', '', 'Homepage', 'homepage.html', 'homepage'),(244, 'Page not found', 'Page not found', '', '', '', 'Page not found', 'page_not_found.html', 'node'),(3, 'Inactive website', '', '', '', '', '<table width="100%" height="100%">\r\n<tbody><tr>\r\n<td width="100%" valign="middle" height="100%" align="center">\r\n<img src="%SITE_LINK%/core/admin/img/bluo_big_logo.gif" />\r\n<div style="padding-top: 60px; font-family: Arial; font-size: 25px; color: rgb(102, 102, 102);">Site unavailable at the moment!</div>\r\n<div style="padding-top: 30px; font-family: Arial; font-size: 20px; color: rgb(102, 102, 102);">Please return soon!</div>\r\n<div style="padding-top: 60px; font-family: Arial; font-size: 15px; color: rgb(102, 102, 102);">Powered by <a target="_blank" href="%CMS_LINK%" style="color: rgb(80, 159, 238);">%CMS_NAME%</a></div>\r\n</td>\r\n</tr>\r\n</tbody></table>', 'inactive.html', 'node'),(101, 'Insite pages', 'Insite pages', '', '', '', '', 'insite_page.html', 'non-menu'),(103, 'Sitemap', 'Sitemap', '', '', '', '', 'index.html', 'node'),(306, 'FAQs', 'FAQs', '', '', '', 'FAQs', 'insite_page.html', 'node');

CREATE TABLE `symph_tour` (  `id` int(11) NOT NULL auto_increment,  `content` text NOT NULL,  `prev` int(11) NOT NULL default '0',  `next` int(11) NOT NULL default '0',  PRIMARY KEY  (`id`)) TYPE=MyISAM AUTO_INCREMENT=7 ;

INSERT INTO `symph_tour` (`id`, `content`, `prev`, `next`) VALUES (10, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">Haideti sa schimbam acum template-ul site-ului. Pentru a face acest lucru, trebuie sa accesam sectiunea "Setari". (tab-ul cu iconita cu o roata dintata).</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Pentru a schimba template-ul, dati click pe Template in aceasta sectiune. Apoi faceti click pe template-ul care va place din lista care apare. In momentul in care ati apasat Salveaza, template-ul se va schimba automat.</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Schimbarea unui template se face cu un click de mouse. In plus, aveti si cateva Optiuni de Design pentru a modifica acest template. Mergeti la pasul urmator pentru a afla despre aceste optiuni.\r\n</div>', 9, 11),(9, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">Pentru a trimite un newsletter, dati click pe "Trimite newsletter" in sectiunea Utilizatori. Dupa cum vedeti, tot ce trebuie sa faceti este sa introduceti textul si sa dati click pe "Trimite".</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Puteti vedea caror utilizatori li se va trimite newsletterul facand click pe "Utilizatori inregistrati" in aceasta sectiune. Veti vedea toti utilizatorii inregistrati intr-o lista.\r\n</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Puteti de asemenea vedea toate newsletterele pe care le-ati trimis deja accesand "Arhiva Newsletter"</div>', 8, 10),(8, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">La stanga arborelui, in partea de sus, exista 4 tab-uri cu iconite. Acestea sunt sectiunile de administrare a site-ului. Navigati printre ele pentru a vedea ce puteti face cu Bluo.</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Toate aceste sectiuni au un meniu in forma de arbore pentru a va fi familiar.\r\n</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Acum mergeti la sectiunea Utilizatori. Haideti sa invatam cate ceva despre newslettere.</div>', 12, 9),(7, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">Haideti sa ne uitam la interfata:</div>\r\n			\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">La stanga se afla structura site-ului afisata ca un arbore. Pentru a administra site-ul, dati click dreapta pe orice pagina din arbore si folositi meniul care apare.</div>\r\n<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Meniul site-ului este de fapt acest arbore. Este generat automat. In momentul in care adaugati, mutati sau stergeti o pagina, meniul site-ului se schimba automat. Nu este nevoie sa schimbati linkuri sau alte informatii de acest gen. Folosit doar meniul de click dreapta si meniul site-ului se va genera automat.\r\n</div>\r\n', 0, 12),(5, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">The "Design Options" feature lets you change the colors and fonts of your template. Play with this feature a bit and click on the "View site" link in the upper left of the interface, near the Bluo logo.</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">You can now see what results you are getting. To restore the old template, go to the Design Options and click on "Restore".\r\n</div>', 4, 0),(4, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">Let''s change the site template. In order to do that, we must go to the "Settings" section (the tab with the small wheel at the left of the tree).</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">To change the template you must access Templates in the menu and click on the template you like. You then have to hit "Save"</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Changing a template is done with one click. Moreover, some templates have "Design Options". Go to the next step to find out more about that.\r\n</div>', 3, 5),(3, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">In order to send a newsletter, click on the "Send Newsletter" menu item. As you can see, all you need to do is insert your text and click on send.</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">You can see what users the newsletter will be sent to by clicking on the "Registered Users" menu item in this section. You have there all your registered users in a list.</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">You can also see all the newsletters you have previously sent by accessing the "Newsletter Archive"</div>', 2, 4),(2, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">At the left of the tree there are 4 tabs with icons. These are the site management sections. Browse through them to get a feel of what you can do.</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">All these sections have a tree-like menu to make things familiar for you.\r\n</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Now go to the Users section. Let''s learn a bit about newsletters.</div>', 6, 3),(1, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">Let''s take a moment to look at the interface:</div>\r\n			\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">At your left you have the site structure displayed as a tree. To manage your site, right click on any page in the tree and use the items in the menu that appears.</div>\r\n<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">The site menu is actually this tree. It is also generated automatically. Once you add, move or delete a page, the site menu changes automatically. You don''t need to change links or other such information. You just use the right click menu and the site menu takes care of itself.</div>\r\n', 0, 6),(11, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">Optiunile de Design va permit sa schimbati culorile si fonturile template-ului. Jucati-va cu aceste optiuni si apoi apasati pe "Vezi site" aflat langa logo-ul Bluo in partea stanga sus.</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Puteti vedea acum rezultatele schimbarilor facute. Pentru a reveni la template-ul initial, accesati din nou Optiuni de Design si apasati pe "Incarca stilurile initiale".</div>', 10, 0),(12, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">Faceti click dreapta pe orice pagina din tree. Va aparea un meniu care va ofera posibilitatea de a edita, muta sau sterge pagina. De asemenea, puteti adauga o subpagina sau sa o dezactivati (vizitatorii site-ului nu o vor putea vizualiza).</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Veti observa ca editarea paginii se face foarte usor cu un editor de tip Word. Modificati continutul si apoi apasati butonul Salveaza. Si mutatul paginii este foarte usor. Trebuie doar sa selectati noua pozitie a paginii in tree si sa apasati butonul Salveaza. Doar 3 clickuri!</div>\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Nu uitati sa verificati modificarile. Apasati pe "Vezi site" din headerul partii de administrare.\r\n</div>', 7, 8),(6, '<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 10px;">Right click on any page. You will see a menu that lets you edit/move or delete a page. You can also add a new page or hide it (make it unavailable for the visitors of the site) . Try it.</div>\r\n			\r\n			<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">You will notice that editing a page is as simple as a word processor. Modify the content and then click save. Moving is also ridiculously simple. Just check the new location and Save. No more than 3 clicks.</div>\r\n<div style="white-space: normal; width: 413px; font-family: Arial; font-size: 12px; color: #333333; padding-left: 10px; padding-top: 5px;">Don''t forget to check the site to see the modifications. Click on the "View site" link near the Bluo logo.</div>\r\n', 1, 2);

CREATE TABLE `symph_users` (  `user_id` int(11) NOT NULL auto_increment,  `user_username` varchar(255) NOT NULL default '',  `user_password` varchar(255) NOT NULL default '',  `user_name` varchar(255) NOT NULL default '',  `user_email` varchar(255) NOT NULL default '',  `user_newsletter` int(11) NOT NULL default '0',  `user_idgrp` tinyint(4) NOT NULL default '0',  `user_registration` date NOT NULL default '0000-00-00',  PRIMARY KEY  (`user_id`)) TYPE=MyISAM PACK_KEYS=0 AUTO_INCREMENT=73 ;

INSERT INTO `symph_users` (`user_id`, `user_username`, `user_password`, `user_name`, `user_email`, `user_newsletter`, `user_idgrp`, `user_registration`) VALUES (61, 'admin', '21232f297a57a5a743894a0e4a801fc3', '', '', 0, 1, '0000-00-00');